export interface Colored {
    r: number;
    g: number;
    b: number;
    a?: number;
}
export declare type ColorConstructorArg = number | Color | Colored | undefined;
export declare class Color implements Colored {
    r: number;
    g: number;
    b: number;
    constructor(r?: ColorConstructorArg, g?: number, b?: number);
    set<T extends Colored>(val: Color | number | T): Color;
    setHex(hex: number): Color;
    getHex(): number;
    clone(): Color;
    copy(color: Color): Color;
    scaled<T extends Colored>(): Colored;
}
export declare class CC {
    static rgbRegEx: RegExp;
    static cache: Record<number, Color>;
    static color(hex: undefined): Color;
    static color(hex: number): Color;
    static color(hex: number[]): Color[];
    static getHex(hex: Array<string | number>): number[];
    static getHex(hex: string | number): number;
}
